import { CheckCircle, Error, Info, WarningRounded } from '@material-ui/icons';
import { Alert as MaterialAlert } from '@material-ui/lab';
import { ColorDynamic } from '@superdispatch/ui';
import { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import { jsx as _jsx } from "react/jsx-runtime";
function colorMixin(textColor, iconColor, backgroundColor, buttonHoverColor) {
  return css(["color:", ";border-color:", ";background-color:", ";& .MuiAlert-icon{color:", ";}& .MuiAlert-action{color:", ";& .MuiIconButton-root{&:hover,&:active{color:", ";}}}"], textColor, textColor, backgroundColor, iconColor, iconColor, buttonHoverColor);
}
var StyledAlert = /*#__PURE__*/styled(MaterialAlert).withConfig({
  displayName: "Alert__StyledAlert",
  componentId: "SD__sc-1j6qebb-0"
})(["&.MuiAlert-outlinedSuccess{", ";}&.MuiAlert-outlinedInfo{", ";}&.MuiAlert-outlinedWarning{", ";}&.MuiAlert-outlinedError{", ";}& .MuiAlert-icon{opacity:1;padding:8px 0;font-size:24px;}& .MuiAlert-action{display:block;padding-top:5px;margin-right:-3px;& .MuiIconButton-root{& .MuiSvgIcon-root{font-size:24px;}}}"], /*#__PURE__*/colorMixin(ColorDynamic.Green500, ColorDynamic.Green300, ColorDynamic.Green50, ColorDynamic.Green400), /*#__PURE__*/colorMixin(ColorDynamic.Blue500, ColorDynamic.Blue300, ColorDynamic.Blue50, ColorDynamic.Blue400), /*#__PURE__*/colorMixin(ColorDynamic.Yellow500, ColorDynamic.Yellow300, ColorDynamic.Yellow50, ColorDynamic.Yellow400), /*#__PURE__*/colorMixin(ColorDynamic.Red500, ColorDynamic.Red300, ColorDynamic.Red50, ColorDynamic.Red400));
function toMaterialSeverity(severity) {
  return severity === 'info' ? 'info' : severity === 'caution' ? 'warning' : severity === 'critical' ? 'error' : 'success';
}
var iconMapping = {
  success: /*#__PURE__*/_jsx(CheckCircle, {}),
  info: /*#__PURE__*/_jsx(Info, {}),
  error: /*#__PURE__*/_jsx(Error, {}),
  warning: /*#__PURE__*/_jsx(WarningRounded, {})
};
export var Alert = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
    children,
    onClose,
    severity = 'positive',
    icon
  } = _ref;
  return /*#__PURE__*/_jsx(StyledAlert, {
    ref: ref,
    variant: "outlined",
    icon: icon,
    iconMapping: iconMapping,
    severity: toMaterialSeverity(severity),
    onClose: onClose,
    children: children
  });
});
if (process.env.NODE_ENV !== "production") Alert.displayName = "Alert";