import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children"],
  _excluded2 = ["in"];
import { ColorDynamic } from '@superdispatch/ui';
import { forwardRef, useEffect, useState } from 'react';
import { CSSTransition } from 'react-transition-group';
// eslint-disable-next-line import/no-internal-modules

import styled, { css, keyframes } from 'styled-components';
import { jsx as _jsx } from "react/jsx-runtime";
function enterMixin(border) {
  return css(["min-height:56px;color:", ";background-color:", ";border-", ":1px #dfe3e8 solid;"], ColorDynamic.Dark500, ColorDynamic.White, border);
}
function enterAnimation(border) {
  return keyframes(["0%{min-height:0;color:", ";background-color:", ";}50%{min-height:56px;color:", ";background-color:", ";}70%{min-height:56px;color:", ";background-color:", ";}100%{", "}"], ColorDynamic.White, ColorDynamic.Dark500, ColorDynamic.White, ColorDynamic.Dark500, ColorDynamic.White, ColorDynamic.Dark500, enterMixin(border));
}
var CustomTransition = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
      children
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_jsx(CSSTransition, _objectSpread(_objectSpread({}, props), {}, {
    ref: ref,
    timeout: 3000,
    classNames: props.className,
    children: /*#__PURE__*/_jsx("div", {
      children: children
    })
  }));
});
if (process.env.NODE_ENV !== "production") CustomTransition.displayName = "CustomTransition";
var BannerContent = /*#__PURE__*/styled(CustomTransition).withConfig({
  displayName: "Banner__BannerContent",
  componentId: "SD__sc-9kw31n-0"
})(_ref2 => {
  var {
    border = 'bottom'
  } = _ref2;
  return css(["height:0;width:100%;overflow:hidden;display:flex;align-items:center;justify-content:center;color:", ";background-color:", ";&-enter-active{animation:", " 2s 1s forwards;}&-enter-done{", ";}&-exit{", ";}&-exit-active{min-height:0;transition:min-height 2s 1s;}"], ColorDynamic.White, ColorDynamic.White, enterAnimation(border), enterMixin(border), enterMixin(border));
});
export var Banner = /*#__PURE__*/forwardRef((_ref3, ref) => {
  var {
      in: inProp
    } = _ref3,
    props = _objectWithoutProperties(_ref3, _excluded2);
  var [isIn, setIn] = useState(false);

  // transition is not triggered on initial render with `in: true`
  useEffect(() => {
    setIn(!!inProp);
  }, [inProp]);
  return /*#__PURE__*/_jsx(BannerContent, _objectSpread({
    ref: ref,
    in: isIn
  }, props));
});
if (process.env.NODE_ENV !== "production") Banner.displayName = "Banner";