import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "endIcon", "startIcon", "tabIndex", "active", "pending", "disabled", "size", "fullWidth", "variant"],
  _excluded2 = ["type"],
  _excluded3 = ["href", "target"];
import { CircularProgress } from '@material-ui/core';
import { Color, ColorDynamic } from '@superdispatch/ui';
import { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
function createButtonVariables(size, _ref) {
  var {
    fontSize = size === 'large' ? 16 : 14,
    lineHeight = size === 'large' ? 24 : 20,
    fontSizeMobile = size === 'large' ? 18 : 16,
    lineHeightMobile = size === 'large' ? 28 : 24,
    paddingX = size === 'large' ? 32 : 16,
    paddingY = size === 'large' ? 8 : size === 'small' ? 2 : 6,
    paddingXMobile = size === 'large' ? 64 : 24,
    paddingYMobile = size === 'large' ? 14 : size === 'small' ? 4 : 10,
    textColor = ColorDynamic.Transparent,
    textColorHovered = textColor,
    textColorDisabled = textColor,
    iconColor = textColor,
    outlineColor = ColorDynamic.Transparent,
    borderColor = ColorDynamic.Transparent,
    borderColorHovered = borderColor,
    borderColorDisabled = borderColor,
    backgroundColor = ColorDynamic.Transparent,
    backgroundColorHovered = backgroundColor,
    backgroundColorActive = backgroundColorHovered,
    backgroundColorDisabled = backgroundColor
  } = _ref;
  return {
    paddingX,
    paddingY,
    fontSize,
    lineHeight,
    paddingXMobile,
    paddingYMobile,
    fontSizeMobile,
    lineHeightMobile,
    textColor,
    borderColor,
    outlineColor,
    backgroundColor,
    textColorHovered,
    borderColorHovered,
    backgroundColorHovered,
    backgroundColorActive,
    textColorDisabled,
    borderColorDisabled,
    backgroundColorDisabled,
    iconColor
  };
}
function getDefaultVariables(size) {
  return createButtonVariables(size, {
    textColor: Color.White,
    outlineColor: ColorDynamic.Blue30,
    backgroundColor: ColorDynamic.Blue300,
    textColorHovered: Color.White,
    backgroundColorHovered: ColorDynamic.Blue500,
    backgroundColorActive: ColorDynamic.Blue400,
    textColorDisabled: Color.White50,
    backgroundColorDisabled: ColorDynamic.Blue30
  });
}
function getPrimaryVariables(size) {
  return getDefaultVariables(size);
}
function getNeutralVariables(size) {
  return createButtonVariables(size, {
    textColor: ColorDynamic.Dark500,
    borderColor: ColorDynamic.Silver500,
    outlineColor: ColorDynamic.Blue30,
    backgroundColor: ColorDynamic.White,
    textColorHovered: ColorDynamic.Blue500,
    borderColorHovered: ColorDynamic.Blue500,
    backgroundColorHovered: ColorDynamic.Blue50,
    backgroundColorActive: ColorDynamic.Blue50,
    textColorDisabled: ColorDynamic.Silver500,
    iconColor: ColorDynamic.Dark100
  });
}
function getCriticalVariables(size) {
  return createButtonVariables(size, {
    textColor: ColorDynamic.Red500,
    borderColor: ColorDynamic.Red500,
    outlineColor: ColorDynamic.Red30,
    backgroundColor: ColorDynamic.Red50,
    backgroundColorHovered: ColorDynamic.Red300Aplha20,
    backgroundColorActive: ColorDynamic.Red10,
    textColorDisabled: ColorDynamic.Red30,
    borderColorDisabled: ColorDynamic.Red30,
    backgroundColorDisabled: ColorDynamic.Red50
  });
}
function getTextVariables(size) {
  return createButtonVariables(size, {
    textColor: ColorDynamic.Blue500,
    outlineColor: ColorDynamic.Blue30,
    textColorHovered: ColorDynamic.Blue500,
    backgroundColorHovered: ColorDynamic.Blue50,
    backgroundColorActive: ColorDynamic.Blue50,
    textColorDisabled: ColorDynamic.Blue30
  });
}
function getInvertedVariables(size) {
  return createButtonVariables(size, {
    textColor: ColorDynamic.White,
    outlineColor: ColorDynamic.White40,
    backgroundColor: ColorDynamic.White20,
    textColorHovered: ColorDynamic.White,
    backgroundColorHovered: ColorDynamic.White40,
    backgroundColorActive: ColorDynamic.White20,
    textColorDisabled: ColorDynamic.White50,
    backgroundColorDisabled: ColorDynamic.White08
  });
}
function getSuccessVariables(size) {
  return createButtonVariables(size, {
    textColor: Color.White,
    outlineColor: ColorDynamic.Green30,
    backgroundColor: ColorDynamic.Green300,
    backgroundColorHovered: ColorDynamic.Green500,
    backgroundColorActive: ColorDynamic.Green500,
    textColorDisabled: Color.White50,
    backgroundColorDisabled: ColorDynamic.Green30
  });
}
var ButtonRoot = /*#__PURE__*/styled.button.withConfig({
  displayName: "Button__ButtonRoot",
  componentId: "SD__sc-1pwdpe3-0"
})(_ref2 => {
  var {
    size,
    theme,
    variant,
    fullWidth
  } = _ref2;
  var variables = variant === 'primary' ? getPrimaryVariables(size) : variant === 'neutral' ? getNeutralVariables(size) : variant === 'critical' ? getCriticalVariables(size) : variant === 'text' ? getTextVariables(size) : variant === 'inverted' ? getInvertedVariables(size) : variant === 'success' ? getSuccessVariables(size) : getDefaultVariables(size);
  return css(JSON.parse('["border:0;margin:0;outline:0;position:relative;vertical-align:middle;cursor:pointer;text-decoration:none;&[aria-disabled=\'true\']{cursor:default;pointer-events:none;}-moz-appearance:none;&::-moz-focus-inner{border-style:none;}-webkit-appearance:none;-webkit-user-select:none;-webkit-tap-highlight-color:transparent;@media print{-webkit-print-color-adjust:exact;}--button-visibility:visible;--button-text-color:",";--button-border-color:",";--button-outline-color:",";--button-background-color:",";--button-icon-color:",";--button-padding-x:","px;--button-padding-y:","px;--button-font-size:","px;--button-line-height:","px;","{--button-padding-x:","px;--button-padding-y:","px;--button-font-size:","px;--button-line-height:","px;}&[aria-disabled=\'true\']{--button-text-color:",";--button-border-color:",";--button-background-color:",";--button-icon-color:",";&[aria-busy=\'true\']{--button-visibility:hidden;}}&[aria-disabled=\'false\']{&[aria-expanded=\'true\']{--button-text-color:",";--button-border-color:",";--button-background-color:",";--button-icon-color:",";}&,&[aria-expanded=\'true\']{&:focus{--button-outline-color:",";}@media (hover:hover) and (pointer:fine){&:hover{--button-text-color:",";--button-border-color:",";--button-background-color:",";span{svg{fill:",";}}}}&:active{--button-background-color:",";}}}display:inline-flex;align-items:center;justify-content:center;min-width:48px;width:",";border-radius:4px;font-family:",";font-weight:",";color:var(--button-text-color);background-color:var(--button-background-color);font-size:var(--button-font-size);line-height:var(--button-line-height);padding:var(--button-padding-y) var(--button-padding-x);box-shadow:inset 0 0 0 1px var(--button-border-color),0 0 0 2px var(--button-outline-color);transition:",";"]'), variables.textColor, variables.borderColor, ColorDynamic.Transparent, variables.backgroundColor, variables.iconColor, variables.paddingXMobile, variables.paddingYMobile, variables.fontSizeMobile, variables.lineHeightMobile, theme.breakpoints.up('sm'), variables.paddingX, variables.paddingY, variables.fontSize, variables.lineHeight, variables.textColorDisabled, variables.borderColorDisabled, variables.backgroundColorDisabled, variables.textColorDisabled, variables.textColorHovered, variables.borderColorHovered, variables.backgroundColorHovered, variables.textColorHovered, variables.outlineColor, variables.textColorHovered, variables.borderColorHovered, variables.backgroundColorHovered, variables.textColorHovered, variables.backgroundColorActive, fullWidth ? '100%' : 'auto', theme.typography.fontFamily, theme.typography.fontWeightBold, theme.transitions.create(['color', 'box-shadow', 'background-color']));
});
var ButtonLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "Button__ButtonLabel",
  componentId: "SD__sc-1pwdpe3-1"
})(["display:inherit;align-items:inherit;justify-content:inherit;visibility:var(--button-visibility);--mui-svg-icon-size:var(--button-line-height);"]);
var ButtonStartIcon = /*#__PURE__*/styled.span.withConfig({
  displayName: "Button__ButtonStartIcon",
  componentId: "SD__sc-1pwdpe3-2"
})(["margin-right:4px;color:var(--button-icon-color);"]);
var ButtonEndIcon = /*#__PURE__*/styled.span.withConfig({
  displayName: "Button__ButtonEndIcon",
  componentId: "SD__sc-1pwdpe3-3"
})(["margin-left:4px;color:var(--button-icon-color);"]);
var ButtonPendingIndicator = /*#__PURE__*/styled.span.withConfig({
  displayName: "Button__ButtonPendingIndicator",
  componentId: "SD__sc-1pwdpe3-4"
})(["left:50%;display:flex;position:absolute;visibility:visible;transform:translate(-50%);"]);
function useButtonProps(_ref3) {
  var {
      children,
      endIcon,
      startIcon,
      tabIndex: tabIndexProp = 0,
      active = false,
      pending = false,
      disabled: disabledProp = false,
      size = 'medium',
      fullWidth = false,
      variant = 'default'
    } = _ref3,
    props = _objectWithoutProperties(_ref3, _excluded);
  var disabled = pending || disabledProp;
  var tabIndex = disabled ? -1 : tabIndexProp;
  return _objectSpread(_objectSpread({}, props), {}, {
    size,
    variant,
    fullWidth,
    tabIndex,
    disabled,
    'aria-busy': pending,
    'aria-expanded': active,
    'aria-disabled': disabled,
    children: /*#__PURE__*/_jsxs(ButtonLabel, {
      children: [!!startIcon && /*#__PURE__*/_jsx(ButtonStartIcon, {
        children: startIcon
      }), children, !!endIcon && /*#__PURE__*/_jsx(ButtonEndIcon, {
        children: endIcon
      }), pending && /*#__PURE__*/_jsx(ButtonPendingIndicator, {
        children: /*#__PURE__*/_jsx(CircularProgress, {
          size: "1em",
          color: "inherit"
        })
      })]
    })
  });
}
export var Button = /*#__PURE__*/forwardRef((_ref4, ref) => {
  var {
      type = 'button'
    } = _ref4,
    props = _objectWithoutProperties(_ref4, _excluded2);
  var buttonProps = useButtonProps(props);
  return /*#__PURE__*/_jsx(ButtonRoot, _objectSpread(_objectSpread({}, buttonProps), {}, {
    ref: ref,
    type: type
  }));
});
if (process.env.NODE_ENV !== "production") Button.displayName = "Button";
export var AnchorButton = /*#__PURE__*/forwardRef((_ref5, ref) => {
  var {
      href,
      target
    } = _ref5,
    props = _objectWithoutProperties(_ref5, _excluded3);
  var buttonProps = useButtonProps(props);
  var rel = target === '_blank' ? 'noopener noreferrer' : undefined;
  return /*#__PURE__*/_jsx(ButtonRoot, _objectSpread(_objectSpread({}, buttonProps), {}, {
    as: "a",
    ref: ref,
    rel: rel,
    href: href,
    target: target
  }));
});
if (process.env.NODE_ENV !== "production") AnchorButton.displayName = "AnchorButton";