import { Typography } from '@material-ui/core';
import { Stack } from '@superdispatch/ui';
import { Children, forwardRef } from 'react';
import styled from 'styled-components';
import { jsx as _jsx } from "react/jsx-runtime";
var ChatContainer = /*#__PURE__*/styled('div').withConfig({
  displayName: "Chat__ChatContainer",
  componentId: "SD__sc-qksih8-0"
})(_ref => {
  var {
    isEmpty
  } = _ref;
  return "\n  display: flex;\n  flex-direction: column-reverse;\n  overflow: auto;\n  justify-content: ".concat(isEmpty ? 'center' : 'end', ";\n  width: 100%;\n  height: 100%;\n  min-width: 300px;\n  max-width: 560px;\n  min-height: 368px;\n  max-height: 696px;\n  padding: 16px;\n  box-sizing: border-box;\n");
});
function emptyPlaceholder(text) {
  return /*#__PURE__*/_jsx(Typography, {
    color: "textSecondary",
    align: "center",
    children: text
  });
}
export var Chat = /*#__PURE__*/forwardRef((_ref2, ref) => {
  var {
    children,
    className,
    emptyText = 'No new messages'
  } = _ref2;
  var isEmpty = Children.toArray(children).length === 0;
  return /*#__PURE__*/_jsx(ChatContainer, {
    "data-testid": "chat-container",
    isEmpty: isEmpty,
    ref: ref,
    className: className,
    children: /*#__PURE__*/_jsx(Stack, {
      space: "small",
      children: isEmpty ? emptyPlaceholder(emptyText) : children
    })
  });
});
if (process.env.NODE_ENV !== "production") Chat.displayName = "Chat";
Chat.displayName = 'Chat';