import { Typography } from '@material-ui/core';
import { formatDate } from '@superdispatch/dates';
import { Inline, Stack } from '@superdispatch/ui';
import { Box } from '@superdispatch/ui-lab';
import { forwardRef } from 'react';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
export var ChatMessage = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
    author,
    role,
    dateTime,
    text,
    variant
  } = _ref;
  var time = formatDate(dateTime, {
    variant: 'Time'
  });
  return /*#__PURE__*/_jsxs(Stack, {
    space: "xxsmall",
    align: variant === 'outgoing' ? 'right' : 'left',
    ref: ref,
    "data-testid": "chat-message",
    children: [/*#__PURE__*/_jsxs(Inline, {
      verticalAlign: "center",
      children: [/*#__PURE__*/_jsx(Typography, {
        color: "textPrimary",
        children: author
      }), /*#__PURE__*/_jsx(Typography, {
        color: "textSecondary",
        children: role
      }), /*#__PURE__*/_jsx(Typography, {
        color: "textSecondary",
        children: time
      })]
    }), /*#__PURE__*/_jsx(Box, {
      display: "inline-block",
      padding: "xsmall",
      marginTop: "none",
      borderRadius: "medium",
      backgroundColor: variant === 'outgoing' ? 'Blue50' : 'Silver200',
      children: /*#__PURE__*/_jsx(Typography, {
        color: "textPrimary",
        children: text
      })
    })]
  });
});
if (process.env.NODE_ENV !== "production") ChatMessage.displayName = "ChatMessage";
ChatMessage.displayName = 'ChatMessage';