import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["fullViewportHeight"];
import { mergeRefs } from '@superdispatch/ui';
import { forwardRef, useLayoutEffect, useRef } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
export var Container = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
      fullViewportHeight
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  var nodeRef = useRef(null);
  useLayoutEffect(() => {
    if (!fullViewportHeight) {
      if (nodeRef.current) {
        nodeRef.current.style.removeProperty('height');
        nodeRef.current.style.removeProperty('--vh');
      }
      return;
    }
    function updateHeight() {
      if (nodeRef.current) {
        // https://css-tricks.com/the-trick-to-viewport-units-on-mobile/
        nodeRef.current.style.setProperty('height', 'calc(var(--vh, 1vh) * 100)');
        nodeRef.current.style.setProperty('--vh', "".concat(window.innerHeight * 0.01, "px"));
      }
    }
    updateHeight();
    window.addEventListener('resize', updateHeight);
    return () => {
      window.removeEventListener('resize', updateHeight);
    };
  }, [fullViewportHeight]);
  return /*#__PURE__*/_jsx("div", _objectSpread({
    ref: mergeRefs(ref, nodeRef)
  }, props));
});
if (process.env.NODE_ENV !== "production") Container.displayName = "Container";
Container.displayName = 'Container';