import { ColorDynamic, Column, Columns, Inline, isEmptyReactNode, useUID } from '@superdispatch/ui';
import { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import { TextBox } from "../text-box/TextBox.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
function descriptionItemIconMixin(size) {
  return css(["width:", "px;height:", "px;& > .MuiSvgIcon-root{font-size:", "px;}"], size, size + 4, size);
}
var DescriptionItemIcon = /*#__PURE__*/styled.div.withConfig({
  displayName: "DescriptionItem__DescriptionItemIcon",
  componentId: "SD__sc-1906hic-0"
})(_ref => {
  var {
    theme
  } = _ref;
  return css(["display:flex;align-items:center;& > .MuiSvgIcon-root{color:", ";}", ";", "{", ";}"], ColorDynamic.Dark100, descriptionItemIconMixin(20), theme.breakpoints.up('sm'), descriptionItemIconMixin(16));
});
export var DescriptionItem = /*#__PURE__*/forwardRef((_ref2, ref) => {
  var {
    icon,
    wrap,
    inset,
    label,
    children,
    fallback,
    id: idProp,
    'aria-label': ariaLabel
  } = _ref2;
  var id = useUID(idProp);
  var labelID = "".concat(id, "-label");
  var isEmptyChildren = isEmptyReactNode(children);
  return /*#__PURE__*/_jsxs(Columns, {
    id: id,
    ref: ref,
    space: "xsmall",
    "aria-label": ariaLabel,
    children: [!!(icon || inset) && /*#__PURE__*/_jsx(Column, {
      width: "content",
      children: /*#__PURE__*/_jsx(DescriptionItemIcon, {
        children: icon
      })
    }), /*#__PURE__*/_jsx(Column, {
      width: "adaptive",
      children: /*#__PURE__*/_jsxs(Inline, {
        space: "xxsmall",
        noWrap: !wrap,
        children: [!!label && /*#__PURE__*/_jsx(TextBox, {
          as: "label",
          id: labelID,
          color: "secondary",
          children: label
        }), /*#__PURE__*/_jsx(TextBox, {
          as: "div",
          noWrap: !wrap,
          wrapOverflow: !!wrap,
          "aria-labelledby": label == null ? undefined : labelID,
          color: isEmptyChildren && label == null ? 'secondary' : 'primary',
          children: isEmptyChildren ? fallback : children
        })]
      })
    })]
  });
});
if (process.env.NODE_ENV !== "production") DescriptionItem.displayName = "DescriptionItem";