import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["variant", "showHelpIcon", "endAction", "children"];
import { Error, Flag, Help, Warning } from '@material-ui/icons';
import { ColorDynamic } from '@superdispatch/ui';
import { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var IconContainer = /*#__PURE__*/styled.div.withConfig({
  displayName: "FlagListItem__IconContainer",
  componentId: "SD__sc-o5bqru-0"
})(["padding:4px;border-radius:50%;background:", ";color:", ";transition:", ";& .MuiSvgIcon-root{font-size:16px;}"], ColorDynamic.Silver200, ColorDynamic.Blue300, _ref => {
  var {
    theme
  } = _ref;
  return theme.transitions.create(['color', 'background-color']);
});
var Content = /*#__PURE__*/styled.div.withConfig({
  displayName: "FlagListItem__Content",
  componentId: "SD__sc-o5bqru-1"
})(["display:flex;align-items:center;width:100%;gap:8px;"]);
var HelpIcon = /*#__PURE__*/styled.div.withConfig({
  displayName: "FlagListItem__HelpIcon",
  componentId: "SD__sc-o5bqru-2"
})(["margin-left:auto;& > svg{font-size:16px;color:", ";}"], ColorDynamic.Dark500);
var EndActions = /*#__PURE__*/styled.div.withConfig({
  displayName: "FlagListItem__EndActions",
  componentId: "SD__sc-o5bqru-3"
})(["display:flex;align-items:center;margin-left:auto;gap:8px;", "{margin-left:0;width:100%;}"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.breakpoints.down('xs');
});
var BannerListItemDanger = /*#__PURE__*/css(["& ", "{background:", ";color:", ";}&:hover{background:", ";}"], IconContainer, ColorDynamic.Red50, ColorDynamic.Red300, ColorDynamic.Red50);
var BannerListItemStandalone = /*#__PURE__*/css(["background:", ";"], ColorDynamic.Silver200);
var BannerListContainer = /*#__PURE__*/styled.div.withConfig({
  displayName: "FlagListItem__BannerListContainer",
  componentId: "SD__sc-o5bqru-4"
})(["display:flex;align-items:center;gap:8px;padding:8px 16px 8px 12px;border:1px solid ", ";background:", ";cursor:default;transition:", ";& + &{border-top:none;}&:last-child{border-radius:0 0 4px 4px;}&:hover{background:", ";& ", "{background:", ";}& ", " > svg{color:", ";}}[data-variant='standalone'] &:not(:hover){", "}", " ", "{flex-direction:column;align-items:flex-start;}"], ColorDynamic.Silver400, ColorDynamic.White, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.transitions.create(['color', 'background-color']);
}, ColorDynamic.Blue50, IconContainer, ColorDynamic.White, HelpIcon, _ref4 => {
  var {
    $variant
  } = _ref4;
  return $variant === 'danger' ? ColorDynamic.Red300 : ColorDynamic.Blue300;
}, BannerListItemStandalone, _ref5 => {
  var {
    $variant
  } = _ref5;
  return $variant === 'danger' ? BannerListItemDanger : null;
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.breakpoints.down('xs');
});
export var FlagListItem = /*#__PURE__*/forwardRef((_ref7, ref) => {
  var {
      variant = 'primary',
      showHelpIcon,
      endAction,
      children
    } = _ref7,
    rest = _objectWithoutProperties(_ref7, _excluded);
  return /*#__PURE__*/_jsxs(BannerListContainer, _objectSpread(_objectSpread({}, rest), {}, {
    ref: ref,
    $variant: variant,
    children: [/*#__PURE__*/_jsxs(Content, {
      children: [/*#__PURE__*/_jsx(IconContainer, {
        children: variant === 'danger' ? /*#__PURE__*/_jsx(Error, {}) : variant === 'warning' ? /*#__PURE__*/_jsx(Warning, {}) : /*#__PURE__*/_jsx(Flag, {})
      }), children, /*#__PURE__*/_jsx(HelpIcon, {
        children: showHelpIcon && /*#__PURE__*/_jsx(Help, {})
      })]
    }), endAction && /*#__PURE__*/_jsx(EndActions, {
      children: endAction
    })]
  }));
});
if (process.env.NODE_ENV !== "production") FlagListItem.displayName = "FlagListItem";