import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import { Drawer, useMediaQuery, useTheme } from '@material-ui/core';
import { ColorDynamic, useResponsiveValue } from '@superdispatch/ui';
import { useMemo, useState } from 'react';
import styled from 'styled-components';
import { NavbarBottomBar } from "./NavbarBottomBar.js";
import { NavbarContext } from "./NavbarContext.js";
import { NavbarList } from "./NavbarList.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var Aside = /*#__PURE__*/styled.aside.withConfig({
  displayName: "Navbar__Aside",
  componentId: "SD__sc-1oiqig8-0"
})(["display:flex;flex-direction:column;overflow:auto;border-right:1px solid ", ";"], ColorDynamic.Silver400);
var Main = /*#__PURE__*/styled.main.withConfig({
  displayName: "Navbar__Main",
  componentId: "SD__sc-1oiqig8-1"
})(["flex:1;display:flex;flex-direction:column;overflow:auto;"]);
export function Navbar(_ref) {
  var {
    footer,
    items,
    header,
    bottomItems,
    children,
    containerStyle,
    hasExtraBadge
  } = _ref;
  var theme = useTheme();
  var [isDrawerOpen, setDrawerOpen] = useState(false);
  var platform = useResponsiveValue('mobile', 'tablet', 'desktop');
  var isMobile = platform === 'mobile';
  var matches = useMediaQuery(theme.breakpoints.up('md'), {
    noSsr: true
  });
  var [isMenuExpanded, setMenuExpanded] = useState(matches);
  var hasBadge = hasExtraBadge || items.some(item => item.badge);
  var ctx = useMemo(() => ({
    isDrawerOpen,
    isMenuExpanded,
    setDrawerOpen,
    setMenuExpanded,
    isNavbarExpanded: isMenuExpanded || isDrawerOpen
  }), [isDrawerOpen, isMenuExpanded, setMenuExpanded, setDrawerOpen]);
  return /*#__PURE__*/_jsx(NavbarContext.Provider, {
    value: ctx,
    children: /*#__PURE__*/_jsxs("div", {
      style: _objectSpread({
        display: 'flex',
        height: '100%',
        flexDirection: isMobile ? 'column' : 'row'
      }, containerStyle),
      children: [!isMobile && /*#__PURE__*/_jsx(Aside, {
        children: /*#__PURE__*/_jsx(NavbarList, {
          header: header,
          items: items,
          footer: footer
        })
      }), /*#__PURE__*/_jsx(Main, {
        children: children
      }), isMobile && /*#__PURE__*/_jsx(NavbarBottomBar, {
        items: bottomItems,
        hasMenuBadge: hasBadge
      }), /*#__PURE__*/_jsx(Drawer, {
        open: isDrawerOpen,
        anchor: "right",
        onClose: () => {
          setDrawerOpen(false);
        },
        PaperProps: {
          style: {
            width: '280px',
            minWidth: '280px'
          }
        },
        children: /*#__PURE__*/_jsx(NavbarList, {
          header: header,
          items: items,
          footer: footer
        })
      })]
    })
  });
}