import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import { Accordion, AccordionSummary } from '@material-ui/core';
import { ExpandMore } from '@material-ui/icons';
import { Color, ColorDark, ColorDynamic, useUID } from '@superdispatch/ui';
import { useEffect, useMemo, useState, createElement as _createElement } from 'react';
import styled from 'styled-components';
import { useNavbarContext } from "./NavbarContext.js";
import { NavbarItem } from "./NavbarItem.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
export var NavbarAccordionLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "NavbarAccordion__NavbarAccordionLabel",
  componentId: "SD__sc-1s7g3kw-0"
})(["flex-grow:1;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;&[data-expanded='false']{display:none;}"]);
var NavbarAccordionRoot = /*#__PURE__*/styled(Accordion).withConfig({
  displayName: "NavbarAccordion__NavbarAccordionRoot",
  componentId: "SD__sc-1s7g3kw-1"
})(["width:100%;color:#c2c4c9;font-size:14px;font-weight:400;line-height:20px;text-decoration:none;outline:none;cursor:pointer;background-color:", ";&[aria-current]{background-color:", ";color:", ";}&.MuiAccordion-root:before{background-color:#1b2638;}&.MuiPaper-elevation0{border:0px;}&[data-gutter]{margin-top:16px;}&[data-gutter].MuiAccordion-root.Mui-expanded{margin-top:16px;}"], _ref => {
  var {
    theme
  } = _ref;
  return theme.palette.type === 'dark' ? ColorDark.White : Color.Dark500;
}, Color.White10, ColorDynamic.White);
var NavbarAccordionSummary = /*#__PURE__*/styled(AccordionSummary).withConfig({
  displayName: "NavbarAccordion__NavbarAccordionSummary",
  componentId: "SD__sc-1s7g3kw-2"
})(["border-left:4px solid transparent;padding-left:20px;&.MuiAccordionSummary-root{max-height:40px;min-height:40px;}&.MuiAccordionSummary-content{align-items:center;}&:hover,&[aria-current],&[data-active='true']{color:", ";background-color:", ";border-left-color:", ";}&[data-expanded='false']{.MuiAccordionSummary-expandIcon{display:none;}}"], Color.White, Color.White10, ColorDynamic.Blue300);
var IconWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarAccordion__IconWrapper",
  componentId: "SD__sc-1s7g3kw-3"
})(["width:24px;margin-right:8px;& svg{font-size:24px;}"]);
export function NavbarAccordion(_ref2) {
  var {
    label,
    icon,
    gutter,
    items,
    onClick: _onClick
  } = _ref2;
  var uid = useUID();
  var {
    setDrawerOpen,
    isNavbarExpanded
  } = useNavbarContext();
  var [isExpanded, setExpanded] = useState(true);

  // sync accordion state with Desktop menu state
  useEffect(() => {
    setExpanded(isNavbarExpanded);
  }, [isNavbarExpanded]);
  var filteredItems = useMemo(() => items.filter(item => !item.hide), [items]);
  return /*#__PURE__*/_jsxs(NavbarAccordionRoot, {
    square: true,
    "data-gutter": !gutter,
    "aria-labelledby": uid,
    expanded: isExpanded,
    onClick: event => {
      _onClick === null || _onClick === void 0 ? void 0 : _onClick(event);
      if (isNavbarExpanded) {
        setExpanded(!isExpanded);
      }
    },
    children: [/*#__PURE__*/_jsxs(NavbarAccordionSummary, {
      "data-active": !isExpanded && items.some(item => item.active),
      "data-expanded": isNavbarExpanded,
      expandIcon: /*#__PURE__*/_jsx(ExpandMore, {}),
      children: [/*#__PURE__*/_jsx(IconWrapper, {
        children: icon
      }), /*#__PURE__*/_jsx(NavbarAccordionLabel, {
        id: uid,
        "data-expanded": isNavbarExpanded,
        children: label
      })]
    }), filteredItems.map(item => {
      var index = filteredItems.indexOf(item);
      var prev = filteredItems[index - 1];
      var {
        ident = 0
      } = item;
      return /*#__PURE__*/_createElement(NavbarItem, _objectSpread(_objectSpread({}, item), {}, {
        key: item.key,
        ident: ident,
        active: item.active,
        gutter: prev && prev.groupKey !== item.groupKey,
        onClick: event => {
          var _item$onClick;
          event.stopPropagation();
          (_item$onClick = item.onClick) === null || _item$onClick === void 0 ? void 0 : _item$onClick.call(item, event);
          if (!event.isDefaultPrevented()) {
            setDrawerOpen(false);
          }
        }
      }));
    })]
  });
}