import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["active", "hasBadge"];
import { BottomNavigation, BottomNavigationAction } from '@material-ui/core';
import { Menu } from '@material-ui/icons';
import { ColorDynamic } from '@superdispatch/ui';
import { useMemo, createElement as _createElement } from 'react';
import styled from 'styled-components';
import { useNavbarContext } from "./NavbarContext.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var StyledBottomNavigation = /*#__PURE__*/styled(BottomNavigation).withConfig({
  displayName: "NavbarBottomBar__StyledBottomNavigation",
  componentId: "SD__sc-9z6v3k-0"
})(["background:", ";"], ColorDynamic.Dark500);
var StyledBottomNavigationAction = /*#__PURE__*/styled(BottomNavigationAction).withConfig({
  displayName: "NavbarBottomBar__StyledBottomNavigationAction",
  componentId: "SD__sc-9z6v3k-1"
})(["&&{background:#1b2638;color:", ";padding:6px 0 8px;line-height:20px;}&:first-child{padding-left:12px;}&:last-child{padding-right:12px;}&.Mui-selected{color:", ";.MuiBottomNavigationAction-label{font-size:0.75rem;}}"], ColorDynamic.Silver500, ColorDynamic.White);
var IconWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarBottomBar__IconWrapper",
  componentId: "SD__sc-9z6v3k-2"
})(["position:relative;"]);
var IconLabel = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarBottomBar__IconLabel",
  componentId: "SD__sc-9z6v3k-3"
})(["display:flex;align-items:center;justify-content:center;font-size:12px;border-radius:50%;color:", ";background:", ";position:absolute;top:0;right:0;width:8px;height:8px;"], ColorDynamic.White, ColorDynamic.Red300);
export function NavbarBottomBar(_ref) {
  var {
    items,
    hasMenuBadge
  } = _ref;
  var {
    isDrawerOpen,
    setDrawerOpen
  } = useNavbarContext();
  var activeItem = useMemo(() => items.find(item => item.active), [items]);
  return /*#__PURE__*/_jsxs(StyledBottomNavigation, {
    value: activeItem === null || activeItem === void 0 ? void 0 : activeItem.value,
    showLabels: true,
    onChange: (_event, newValue) => {
      if (newValue) {
        if (newValue === 'menu') {
          setDrawerOpen(!isDrawerOpen);
        } else {
          setDrawerOpen(false);
        }
      }
    },
    children: [items.map(_ref2 => {
      var {
          active,
          hasBadge
        } = _ref2,
        item = _objectWithoutProperties(_ref2, _excluded);
      return /*#__PURE__*/_createElement(StyledBottomNavigationAction, _objectSpread(_objectSpread({}, item), {}, {
        key: item.value,
        icon: hasBadge ? /*#__PURE__*/_jsxs(IconWrapper, {
          children: [/*#__PURE__*/_jsx(IconLabel, {}), item.icon]
        }) : item.icon
      }));
    }), /*#__PURE__*/_jsx(StyledBottomNavigationAction, {
      value: "menu",
      label: "Menu",
      icon: hasMenuBadge ? /*#__PURE__*/_jsxs(IconWrapper, {
        children: [/*#__PURE__*/_jsx(IconLabel, {}), /*#__PURE__*/_jsx(Menu, {
          fontSize: "small"
        })]
      }) : /*#__PURE__*/_jsx(Menu, {
        fontSize: "small"
      })
    })]
  });
}