import { alpha } from '@material-ui/core';
import { Color, ColorDynamic, useUID } from '@superdispatch/ui';
import styled from 'styled-components';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
export var NavbarBadge = /*#__PURE__*/styled.span.withConfig({
  displayName: "NavbarItem__NavbarBadge",
  componentId: "SD__sc-1pvzq3w-0"
})(["flex-shrink:0;padding:4px 6px;min-width:20px;line-height:12px;font-size:12px;font-weight:400;border-radius:10px;text-align:center;background:", ";&[data-variant='primary']{color:", ";background:", ";}&[data-variant='danger']{color:", ";background:", ";}"], /*#__PURE__*/alpha(Color.White, 0.05), Color.White, ColorDynamic.Blue300, Color.White, ColorDynamic.Red300);
export var NavbarLabel = /*#__PURE__*/styled.span.withConfig({
  displayName: "NavbarItem__NavbarLabel",
  componentId: "SD__sc-1pvzq3w-1"
})(["flex-grow:1;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;"]);
var NavbarItemRoot = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarItem__NavbarItemRoot",
  componentId: "SD__sc-1pvzq3w-2"
})(["width:100%;display:flex;align-items:center;color:#c2c4c9;font-size:14px;font-weight:400;line-height:20px;text-decoration:none;outline:none;cursor:pointer;padding:8px 16px;border-left:4px solid transparent;&[aria-current],&[data-active='true']{color:", ";background-color:", ";border-left-color:", ";}&:hover{background-color:", ";color:", ";border-left-color:", ";}"], Color.White, Color.White10, ColorDynamic.Blue300, Color.White08, Color.White, ColorDynamic.Blue300);
var IconWrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarItem__IconWrapper",
  componentId: "SD__sc-1pvzq3w-3"
})(["width:24px;margin-right:8px;& svg{font-size:24px;}"]);
export function NavbarItem(_ref) {
  var {
    label,
    gutter,
    badge,
    icon,
    component,
    onClick,
    variant,
    ident = 0,
    active
  } = _ref;
  var uid = useUID();
  return /*#__PURE__*/_jsxs(NavbarItemRoot, {
    as: component,
    onClick: onClick,
    "aria-labelledby": uid,
    "data-active": active,
    style: {
      marginTop: gutter ? '16px' : '0',
      paddingLeft: (ident + 1) * 20
    },
    children: [/*#__PURE__*/_jsx(IconWrapper, {
      children: icon
    }), /*#__PURE__*/_jsx(NavbarLabel, {
      id: uid,
      children: label
    }), badge != null && /*#__PURE__*/_jsx(NavbarBadge, {
      "data-variant": variant,
      children: badge
    })]
  });
}