import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import { IconButton } from '@material-ui/core';
import { Menu as MenuIcon, MenuOpen } from '@material-ui/icons';
import { Color, ColorDark, ColorDynamic, Inline, useResponsiveValue } from '@superdispatch/ui';
import { useMemo, createElement as _createElement } from 'react';
import styled from 'styled-components';
import { NavbarAccordion } from "./NavbarAccordion.js";
import { useNavbarContext } from "./NavbarContext.js";
import { NavbarBadge, NavbarItem, NavbarLabel } from "./NavbarItem.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var Header = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarList__Header",
  componentId: "SD__sc-19zrmxc-0"
})(["margin:0 16px 8px;display:flex;flex-shrink:0;align-items:center;justify-content:space-between;position:sticky;"]);
var Wrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarList__Wrapper",
  componentId: "SD__sc-19zrmxc-1"
})(["display:flex;flex:1;flex-direction:column;overflow:hidden;padding-top:16px;background:", ";transition:width 0.3s linear;height:100%;width:", ";&[data-expanded='true']{width:", ";}&[data-expanded='false']{width:", ";& > ", "{justify-content:center;}}"], _ref => {
  var {
    theme
  } = _ref;
  return theme.palette.type === 'dark' ? ColorDark.White : Color.Dark500;
}, _ref2 => {
  var {
    isMobile
  } = _ref2;
  return isMobile ? '280px' : 'initial';
}, _ref3 => {
  var {
    isMobile
  } = _ref3;
  return isMobile ? '280px' : '240px';
}, _ref4 => {
  var {
    isMobile
  } = _ref4;
  return isMobile ? '280px' : '72px';
}, Header);
var ExpandIconButton = /*#__PURE__*/styled(IconButton).withConfig({
  displayName: "NavbarList__ExpandIconButton",
  componentId: "SD__sc-19zrmxc-2"
})(["color:", ";&&:focus{background-color:inherit;}"], ColorDynamic.Dark100);
var Footer = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarList__Footer",
  componentId: "SD__sc-19zrmxc-3"
})(["flex-grow:1;display:flex;align-items:flex-end;margin:16px 0 8px;position:sticky;"]);
var Root = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarList__Root",
  componentId: "SD__sc-19zrmxc-4"
})(["color:inherit;background-color:unset;border-left:unset;font-size:14px;font-weight:400;line-height:20px;text-decoration:none;padding:8px 16px;svg{font-size:24px;color:", ";}"], ColorDynamic.Dark100);
export function NavbarMenuItem(_ref5) {
  var {
    label,
    icon,
    onClick,
    component
  } = _ref5;
  return /*#__PURE__*/_jsx(Root, {
    as: component,
    onClick: onClick,
    children: /*#__PURE__*/_jsxs(Inline, {
      space: "xsmall",
      verticalAlign: "center",
      children: [icon, /*#__PURE__*/_jsx(NavbarLabel, {
        children: label
      })]
    })
  });
}
var Content = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarList__Content",
  componentId: "SD__sc-19zrmxc-5"
})(["height:100%;min-height:50px;overflow-y:auto;overflow-x:hidden;&[aria-expanded='false']{", ",", "{display:none;}}&::-webkit-scrollbar{width:10px;height:10px;}&::-webkit-scrollbar-track{background-color:transparent;}&::-webkit-scrollbar-thumb{background-color:", ";border-radius:100vw;margin-bottom:100px;}"], NavbarBadge, NavbarLabel, ColorDark.Silver500);
export function NavbarList(_ref6) {
  var {
    header,
    items,
    footer
  } = _ref6;
  var platform = useResponsiveValue('mobile', 'tablet', 'desktop');
  var isMobile = platform === 'mobile';
  var {
    isMenuExpanded,
    isDrawerOpen,
    setDrawerOpen,
    setMenuExpanded
  } = useNavbarContext();
  var isSidebarOpened = isMobile ? isDrawerOpen : isMenuExpanded;
  var filteredItems = useMemo(() => items.filter(item => {
    return !item.hide && (isSidebarOpened || !!item.icon);
  }).map(item => _objectSpread(_objectSpread({}, item), {}, {
    menuGroupKey: item.groupKey
  })), [items, isSidebarOpened]);
  return /*#__PURE__*/_jsxs(Wrapper, {
    isMobile: isMobile,
    "data-expanded": isSidebarOpened,
    children: [/*#__PURE__*/_jsxs(Header, {
      children: [isSidebarOpened && header, !isMobile && /*#__PURE__*/_jsx(ExpandIconButton, {
        disableRipple: true,
        style: isMenuExpanded ? {
          paddingRight: 0
        } : {},
        onClick: () => {
          setMenuExpanded(!isMenuExpanded);
        },
        children: isMenuExpanded ? /*#__PURE__*/_jsx(MenuOpen, {}) : /*#__PURE__*/_jsx(MenuIcon, {})
      })]
    }), /*#__PURE__*/_jsx(Content, {
      "aria-expanded": isSidebarOpened,
      children: filteredItems.map(item => {
        var index = filteredItems.indexOf(item);
        var prev = filteredItems[index - 1];
        if ('items' in item) {
          return /*#__PURE__*/_createElement(NavbarAccordion, _objectSpread(_objectSpread({}, item), {}, {
            key: item.key,
            gutter: prev && prev.groupKey !== item.groupKey,
            onClick: item.onClick
          }));
        }
        return /*#__PURE__*/_createElement(NavbarItem, _objectSpread(_objectSpread({}, item), {}, {
          key: item.key,
          gutter: prev && prev.groupKey !== item.groupKey,
          onClick: event => {
            var _item$onClick;
            (_item$onClick = item.onClick) === null || _item$onClick === void 0 ? void 0 : _item$onClick.call(item, event);
            if (!event.isDefaultPrevented()) {
              setDrawerOpen(false);
            }
          }
        }));
      })
    }), /*#__PURE__*/_jsx(Footer, {
      children: footer
    })]
  });
}