import { Menu, MenuItem, Typography } from '@material-ui/core';
import { Color, ColorDynamic, Inline } from '@superdispatch/ui';
import { useState } from 'react';
import styled from 'styled-components';
import { useNavbarContext } from "./NavbarContext.js";
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
var Divider = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarMenu__Divider",
  componentId: "SD__sc-1c8icpt-0"
})(["border-bottom:1px solid ", ";margin:8px -16px;"], ColorDynamic.Silver400);
var StyledMenuItem = /*#__PURE__*/styled(MenuItem).withConfig({
  displayName: "NavbarMenu__StyledMenuItem",
  componentId: "SD__sc-1c8icpt-1"
})(["& svg{font-size:24px;color:", ";}"], ColorDynamic.Dark100);
var Wrapper = /*#__PURE__*/styled.div.withConfig({
  displayName: "NavbarMenu__Wrapper",
  componentId: "SD__sc-1c8icpt-2"
})(["width:100%;padding:8px 16px;cursor:pointer;background:", ";border-left:4px solid ", ";&:hover{border-left-color:", ";background:", ";}"], Color.White10, _ref => {
  var {
    active
  } = _ref;
  return active ? ColorDynamic.Blue300 : 'transparent';
}, ColorDynamic.Blue300, Color.White08);
export function NavbarMenu(_ref2) {
  var {
    items,
    children
  } = _ref2;
  var {
    setDrawerOpen
  } = useNavbarContext();
  var [anchor, setAnchor] = useState(null);
  function showProfileMenu(event) {
    setAnchor(event.currentTarget);
  }
  function hideProfileMenu() {
    setAnchor(null);
    setDrawerOpen(false);
  }
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(Wrapper, {
      onClick: showProfileMenu,
      active: !!anchor,
      children: children
    }), /*#__PURE__*/_jsx(Menu, {
      open: !!anchor,
      anchorEl: anchor,
      onClose: hideProfileMenu,
      onClick: hideProfileMenu,
      anchorOrigin: {
        vertical: 'top',
        horizontal: 'center'
      },
      transformOrigin: {
        vertical: 'bottom',
        horizontal: 'center'
      },
      children: items.filter(item => item.visible !== false).flatMap((item, index, arr) => {
        return [/*#__PURE__*/_jsx(StyledMenuItem, {
          onClick: item.onClick,
          children: /*#__PURE__*/_jsxs(Inline, {
            space: "small",
            verticalAlign: "center",
            children: [item.icon, /*#__PURE__*/_jsx(Typography, {
              style: {
                color: ColorDynamic.Dark500
              },
              children: item.label
            })]
          })
        }, item.key), index !== arr.length - 1 && /*#__PURE__*/_jsx(Divider, {}, "".concat(item.key, "-divider"))];
      })
    })]
  });
}