import { ColorDynamic, Column, Columns, useUID } from '@superdispatch/ui';
import { forwardRef } from 'react';
import styled from 'styled-components';
import { TextBox } from "../text-box/TextBox.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var SidebarRoot = /*#__PURE__*/styled.aside.withConfig({
  displayName: "Sidebar__SidebarRoot",
  componentId: "SD__sc-b77o22-0"
})(["top:0;position:sticky;overflow-y:auto;overflow-x:hidden;height:100vh;background-color:", ";border-right:1px solid ", ";"], ColorDynamic.White, ColorDynamic.Silver400);
var SidebarHeader = /*#__PURE__*/styled.div.withConfig({
  displayName: "Sidebar__SidebarHeader",
  componentId: "SD__sc-b77o22-1"
})(["top:0;z-index:2;position:sticky;padding-left:24px;padding-right:24px;padding-bottom:8px;background-color:", ";"], ColorDynamic.White);
var SidebarTitle = /*#__PURE__*/styled.div.withConfig({
  displayName: "Sidebar__SidebarTitle",
  componentId: "SD__sc-b77o22-2"
})(["height:64px;max-height:64px;display:flex;align-items:center;"]);
export var Sidebar = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
    title,
    count,
    header,
    children,
    id: idProp
  } = _ref;
  var id = useUID(idProp);
  var titleID = "".concat(id, "-title");
  return /*#__PURE__*/_jsxs(SidebarRoot, {
    id: id,
    ref: ref,
    children: [/*#__PURE__*/_jsxs(SidebarHeader, {
      children: [title && /*#__PURE__*/_jsx(SidebarTitle, {
        children: /*#__PURE__*/_jsxs(Columns, {
          space: "xsmall",
          align: "center",
          children: [/*#__PURE__*/_jsx(Column, {
            width: "fluid",
            children: /*#__PURE__*/_jsx(TextBox, {
              variant: "heading-2",
              noWrap: true,
              id: titleID,
              children: title
            })
          }), !!count && /*#__PURE__*/_jsx(Column, {
            width: "content",
            children: /*#__PURE__*/_jsx(TextBox, {
              color: "secondary",
              children: count
            })
          })]
        })
      }), header]
    }), /*#__PURE__*/_jsx("div", {
      "aria-labelledby": titleID,
      children: children
    })]
  });
});
if (process.env.NODE_ENV !== "production") Sidebar.displayName = "Sidebar";