import { useCollapseBreakpoint } from '@superdispatch/ui';
import { createContext, forwardRef, useContext, useMemo, useState } from 'react';
import styled from 'styled-components';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var Context = /*#__PURE__*/createContext(null);
export function useSidebarContext() {
  var context = useContext(Context);
  if (!context) {
    throw new Error('SidebarContext is used outside Provider');
  }
  return context;
}
var SidebarContainerSidebar = /*#__PURE__*/styled.div.withConfig({
  displayName: "SidebarContainer__SidebarContainerSidebar",
  componentId: "SD__sc-uibj1m-0"
})(["height:inherit;max-height:inherit;min-height:inherit;width:240px;"]);
var SidebarContainerContent = /*#__PURE__*/styled.div.withConfig({
  displayName: "SidebarContainer__SidebarContainerContent",
  componentId: "SD__sc-uibj1m-1"
})(["height:inherit;max-height:inherit;min-height:inherit;"]);
var SidebarContainerRoot = /*#__PURE__*/styled.div.withConfig({
  displayName: "SidebarContainer__SidebarContainerRoot",
  componentId: "SD__sc-uibj1m-2"
})(["display:flex;height:inherit;max-height:inherit;min-height:inherit;& ", "{width:calc(100% - 240px);min-width:calc(100% - 240px);max-width:calc(100% - 240px);}&[data-visibility='sidebar'] ", "{width:100%;}&[data-visibility='sidebar'] ", "{display:none;}&[data-visibility='content'] ", "{display:none;}&[data-visibility='content'] ", "{width:100%;max-width:unset;}"], SidebarContainerContent, SidebarContainerSidebar, SidebarContainerContent, SidebarContainerSidebar, SidebarContainerContent);
export var SidebarContainer = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
    sidebar,
    children
  } = _ref;
  var isCollapsed = useCollapseBreakpoint('sm');
  var [visibilityState, setVisibilityState] = useState('sidebar');
  var visibility = isCollapsed ? visibilityState : 'both';
  var context = useMemo(() => {
    return {
      openSidebar: () => {
        setVisibilityState('sidebar');
      },
      openSidebarContent: () => {
        setVisibilityState('content');
      }
    };
  }, []);
  return /*#__PURE__*/_jsx(Context.Provider, {
    value: context,
    children: /*#__PURE__*/_jsxs(SidebarContainerRoot, {
      ref: ref,
      "data-visibility": visibility,
      children: [/*#__PURE__*/_jsx(SidebarContainerSidebar, {
        children: sidebar
      }), /*#__PURE__*/_jsx(SidebarContainerContent, {
        children: children
      })]
    })
  });
});
if (process.env.NODE_ENV !== "production") SidebarContainer.displayName = "SidebarContainer";