import { AppBar, Toolbar } from '@material-ui/core';
import { Column, Columns, Stack } from '@superdispatch/ui';
import { useLayoutEffect, useRef } from 'react';
import styled, { css } from 'styled-components';
import { Box } from "../box/Box.js";
import { TextBox } from "../text-box/TextBox.js";
import { SidebarBackButton } from "./SidebarBackButton.js";
import { useSidebarContext } from "./SidebarContainer.js";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var SidebarAppBar = /*#__PURE__*/styled(AppBar).withConfig({
  displayName: "SidebarContent__SidebarAppBar",
  componentId: "SD__sc-zpgf61-0"
})(_ref => {
  var {
    theme
  } = _ref;
  return css(["", "{&&{border-left:transparent;}}"], theme.breakpoints.up('sm'));
});
var ToolbarContent = /*#__PURE__*/styled.div.withConfig({
  displayName: "SidebarContent__ToolbarContent",
  componentId: "SD__sc-zpgf61-1"
})(["flex:1;padding:16px;"]);
export function SidebarContent(_ref2) {
  var {
    dense,
    action,
    title,
    children,
    onBack,
    openOnMount,
    closeOnUnmount
  } = _ref2;
  var isOpenedOnMount = useRef(false);
  var isClosedOnMount = useRef(false);
  var {
    openSidebarContent,
    openSidebar
  } = useSidebarContext();
  useLayoutEffect(() => {
    if (openOnMount) {
      if (isOpenedOnMount.current) {
        // eslint-disable-next-line no-console
        console.warn('[SidebarContent]: "openOnMount" should not change during lifecycle of the component.');
      } else {
        isOpenedOnMount.current = true;
        openSidebarContent();
      }
    }
  }, [openOnMount, openSidebarContent]);
  useLayoutEffect(() => {
    return () => {
      if (closeOnUnmount) {
        if (isClosedOnMount.current) {
          // eslint-disable-next-line no-console
          console.warn('[SidebarContent]: "closeOnUnmount" should not change during lifecycle of the component.');
        } else {
          isClosedOnMount.current = true;
          openSidebar();
        }
      }
    };
  }, [openSidebar, closeOnUnmount]);
  return /*#__PURE__*/_jsxs(Stack, {
    space: "none",
    children: [/*#__PURE__*/_jsx(SidebarAppBar, {
      children: /*#__PURE__*/_jsx(Toolbar, {
        disableGutters: true,
        children: /*#__PURE__*/_jsx(ToolbarContent, {
          children: /*#__PURE__*/_jsxs(Columns, {
            align: ['top', 'center'],
            space: "small",
            children: [/*#__PURE__*/_jsx(Column, {
              width: "content",
              children: /*#__PURE__*/_jsx(SidebarBackButton, {
                onClick: onBack
              })
            }), /*#__PURE__*/_jsx(Column, {
              children: /*#__PURE__*/_jsxs(Columns, {
                space: "small",
                collapseBelow: "tablet",
                reverse: [true, false],
                align: ['bottom', 'center'],
                children: [/*#__PURE__*/_jsx(Column, {
                  children: /*#__PURE__*/_jsx(TextBox, {
                    variant: "heading-2",
                    children: title
                  })
                }), action && /*#__PURE__*/_jsx(Column, {
                  width: "content",
                  children: action
                })]
              })
            })]
          })
        })
      })
    }), /*#__PURE__*/_jsx(Box, {
      padding: dense ? 'none' : ['small', 'medium'],
      children: children
    })]
  });
}