import { Avatar, Checkbox } from '@material-ui/core';
import { forwardRef, useMemo } from 'react';
import styled from 'styled-components';
import { useSidebarMenuItemContext } from "./SidebarMenuItemContext.js";
import { jsx as _jsx } from "react/jsx-runtime";
function stopPropagation(event) {
  event.stopPropagation();
}
var SidebarMenuItemAvatarCheckbox = /*#__PURE__*/styled.div.withConfig({
  displayName: "SidebarMenuItemAvatar__SidebarMenuItemAvatarCheckbox",
  componentId: "SD__sc-17mkvc7-0"
})(["margin:-5px;"]);
export var SidebarMenuItemAvatar = /*#__PURE__*/forwardRef((_ref, ref) => {
  var {
    children,
    value,
    onChange: _onChange
  } = _ref;
  var {
    hovered,
    disabled
  } = useSidebarMenuItemContext();
  var initials = useMemo(() => {
    var matches = children.match(/\b\w/g) || [];
    var first = matches.shift() || '';
    var last = matches.pop() || '';
    return (first + last).toUpperCase();
  }, [children]);
  if (value === true || hovered && value != null) {
    return /*#__PURE__*/_jsx(SidebarMenuItemAvatarCheckbox, {
      children: /*#__PURE__*/_jsx(Checkbox, {
        color: "primary",
        checked: value,
        disabled: disabled,
        onClick: stopPropagation,
        onMouseDown: stopPropagation,
        onTouchStart: stopPropagation,
        onChange: (_, checked) => {
          _onChange === null || _onChange === void 0 ? void 0 : _onChange(checked);
        }
      })
    });
  }
  return /*#__PURE__*/_jsx(Avatar, {
    ref: ref,
    "aria-hidden": true,
    children: initials
  });
});
if (process.env.NODE_ENV !== "production") SidebarMenuItemAvatar.displayName = "SidebarMenuItemAvatar";